/**
 * @file  DFFileRawFirmware.h
 * @brief Schnittstelle fuer die Klasse CDFFileRawFirmware.
 */
//////////////////////////////////////////////////////////////////////
#ifndef _DFFILERAWFIRMWARE_H_
#define _DFFILERAWFIRMWARE_H_

#ifdef _WIN32
#pragma warning(disable : 4996)
#endif

// Basisklasse 
#include "DFFileIntelHex.h"
// Hilfsklassen
#include "../Common/ATmega.h"

class CDFFileRawFirmware : public CDFFileIntelHex
{
public:
	CDFFileRawFirmware();
	virtual ~CDFFileRawFirmware();

	void Reset();
	inline CATmega *GetController() { return &m_controller; };
	inline unsigned int GetSizeData() { return m_sizeData; };

	int Load(char *fileName);
	int Save(char *fileName, unsigned char append = 0);

protected:
	unsigned int m_sizeData;
	CATmega m_controller;

};

#endif

