{----------------------------------------------------------------------------------------------------------------------}
{ DATAFOX GMBH (2005) 36124 Eichenzell, Sachsenhausen 3-7, e-mail:  www.datafox.de                                     }                         
{----------------------------------------------------------------------------------------------------------------------}
{    Demotool fr PZE-Master IV Serie                                                                                  }
{                                                                                                                      }
{   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                            }
{    Autor          :  Jens Leuthold  (JML)                                                                            }
{   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                            }
{    Erstellt am    :  08.09.2005                                                                                      }
{    Erstellt mit   :  Borland Delphi 7 Architect
{
{    Update   am    : 02.05.2011  von Lutz Mhe
{    Erstellt mit   : Rad Studio 2009
{    nderungen:
{    DllAufrufe:    Array of char gendert in Array of AnsiChar -Pchar in PansiChar
{    Callbackfunktion: Rckgabewert                                                              }
{   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                            }
{    Unit           :  mLoadData.pas                                                                                   }
{    Version        :  1.00                                                                                            }
{ ---------------------------------------------------------------------------------------------------------------------}
{    Art der Auflistung                       : none                                                                   }
{    Verwendete Anzeigebreite                 : 120 Zeichen                                                            }
{                                                                                                                      }
{ ---------------------------------------------------------------------------------------------------------------------}
{ Demoprogramm fr PZE-Master IV:                                                                                      }
{    Mit diesem Progamm knnen Daten aus dem Gert ber RS232 oder TCP/IP ausgelesen werden.                           }
{    Fr jede Datensatzbeschreibung wird eine Tabelle erzeugt und die zugehrigen Daten in                             }
{    ihr angezeigt.                                                                                                    }
{    Auserdem werden die Daten fortlaufen in entsprechende Dateien geschrieben die im                                  }
{    Ausfhrungsverzeichnis der Anwendung liegen. Pro Datensatzbeschreibung wird eine                                  }
{    Seperate TXT-Datei erzeugt, die Datenfelder sind TAB-getrennt abgelegt.                                           }
{  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ }
{                                                                                                                      }
{ Der Quellcode darf frei verwendet werden. Eine Haftung fr den Einsatz dieser Software und Teilen des Quellcodes     }
{ wird vom Autor ausgeschlossen.


                                                                                       }
{----------------------------------------------------------------------------------------------------------------------}
unit mLoadData;

interface

uses
  LinkSDFComDLL,        // DLL-DFCom statisch Einbinden
  DFUtility,            // Hilfsfunktionen
  CommCtrl,
  StrUtils,
  Windows, Messages,
  SysUtils, Variants,
  Classes, Graphics,
  Controls, Forms,
  Dialogs, StdCtrls,
  ExtCtrls, ComCtrls,
  Grids;

function OnProgress(): Integer;
function DecodeFieldType(fieldType: Integer): String;
function GetLsDescription(SourceId: Cardinal; Dest: TObject; BusNumber: Integer; ByMethod: Integer=1): Integer;
function GetDsDescription(SourceId: Cardinal; Dest: TObject; BusNumber: Integer; ByMethod: Integer=1): Integer;
function DsData(SourceId: Cardinal; Dest: TObject; BusNumber: Integer; ByMethod: Integer=1): Integer;

type
  TForm3 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    Bevel2: TBevel;
    Label4: TLabel;
    Label1: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Panel3: TPanel;
    Bevel1: TBevel;
    Label3: TLabel;
    ComboBox5: TComboBox;
    Label7: TLabel;
    ComboBox4: TComboBox;
    Panel4: TPanel;
    Button1: TButton;
    Panel5: TPanel;
    StatusBar1: TStatusBar;
    Edit2: TEdit;
    Edit3: TEdit;
    Button2: TButton;
    TreeView1: TTreeView;
    Button3: TButton;
    Panel6: TPanel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label2: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Button4: TButton;
    Button5: TButton;
    ProgressBar1: TProgressBar;
    Panel7: TPanel;
    Bevel3: TBevel;
    Button6: TButton;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form3: TForm3;
  
  ChannelNum       : Integer;
  ComPort          : array [0..5] of Char;   // Speichert die ausgewhlte Schnittstelle
  BaudRate         : Integer;
  TimeOut          : Integer;
  BusNum           : Integer;                // Speichert die ausgewhlte Busnummer


  mPageControl     : TPageControl;
  mListView        : TListView;
  tmpTList         : TTreeView;
  tmpgInt          : Integer;

implementation

{$R *.dfm}
//----------------------------------------------------------------------------------------------------------------------
function  OnProgress(): Integer;
begin

  if(Form3.ProgressBar1.Position < 100)then begin
     Form3.ProgressBar1.Position:=Form3.ProgressBar1.Position+1;
    end else begin
    Form3.ProgressBar1.Position :=0;
  end;
  Result:=1;
end;
//----------------------------------------------------------------------------------------------------------------------
// denn FieldType in einen Text bersetzen
function DecodeFieldType(fieldType: Integer): String;
begin

  case fieldType of
  // ftUnsingnetInt=1      fest  4 Byte
  1: begin
     Result:='4 Byte ohne Vorzeichen';
  end;
  // ftDateTime=2          fest  7 Byte (yyyy,mm,dd-h:m:s)
  2: begin
    Result:='Datum und Uhrzeit';
  end;
  // ftAsciiInt=3          max  20 Byte (es sind jedoch nur Ziffern erlaubt)
  3: begin
     Result:='Zeichenkette (nur Ziffern)';
  end;
  // ftAsciiChar=4         max  20 Byte (Alpha-Numerisch ASCII)
  4: begin
     Result:='Zeichenkette (ASCII-Zeichen)';
  end;
  // ftDate=5              fest  4 Byte (yyyy,mm,dd)
  5: begin
     Result:='Datum';
  end;
  // ftTime=6              fest  3 Byte (hh:mm:ss)
  6: begin
     Result:='Uhrzeit';
     end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function GetLsDescription(SourceId: Cardinal; Dest: TObject; BusNumber: Integer; ByMethod: Integer=1): Integer;
var
  i                  : Integer;
  j                  : Integer;
  err                : Integer;
  tmpNode            : TTreeNode;
  tmpString          : array [0..255] of AnsiChar;

  fieldCount         : Integer;
  fieldName          : array [0..16] of AnsiChar;
  fieldType          : Integer;
  fieldLength        : Integer;                    // mit NullTerminierung
  fieldLengthNoTerm  : Integer;                    // ohne NullTerminierung

  tableName          : array [0..16] of AnsiChar;
  tableLength        : Integer;                    // mit NullTerminierung
  tableLengthNoTern  : Integer;                    // ohne NullTerminierung
  tableRecord        : PDSFieldRec;                // in LinkSDFComDLL definiert
  tableVar           : Integer;                    // Wert immer 0 (Null)

begin

  err:=0;
  tableVar:=0;

  if(ByMethod > 0)then begin

    // Prfen ob eine gltige Verbindung zum Gert oder zu einer SourceQuelle besteht
    if(DFCGetComPort(SourceId)=-1)then begin
      Result:=-1; Exit;
    end;

    // wenn Methode =1 wird direkt vom Gert die Listensatzbeschreibung gelesen
    if(ByMethod = 1)then begin

      // Listensatzbeschreibung aus Gert laden
      if(DFCLoadListenbeschreibung(SourceId,BusNumber,@err)=0) then begin
        Result:=err; Exit;
      end;
      //~~~~~~~~~~~~~~~ Dest Sender TTreeView ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      if(Dest is TTreeView)then begin
        with (Dest as TTreeView).Items do
        begin
          Clear;
          // Anzahl der Listen ermitteln
          for i:=0 to DFCListBCnt(SourceId)-1 do begin
            tableLength:=0;
            tableLengthNoTern:=0;

            // Name der Tabelle(Liste) und Anzahl Felder ermitteln
            DFCListBDatensatz(SourceId, i, @tableName, @fieldCount,@tableVar);

            // Stammknoten hinzufgen
            new(tableRecord);
            FillMemory(tableRecord,SizeOf(TDSFieldRec),$0);
            StrLCopy(tableRecord^.Name,tableName,SizeOf(tableRecord^.Name)-1);
            tableRecord^.TypeCode:=0;
            tableRecord^.Number:=i;
            tableRecord^.ParentNumber:=-1;
            tmpNode := AddObject(nil, tableName, tableRecord);


            for j:=0 to fieldCount-1 do begin

              DFCListBFeld(SourceId, i, j, @fieldName, @fieldType, @fieldLength);
              fieldLengthNoTerm:=fieldLength;

              StrCopy(tmpString,PAnsiChar(DecodeFieldType(fieldType)));
              if(fieldType=3)or(fieldType=4)then begin
                Dec(fieldLengthNoTerm);
              end;
              // Untergeordneten Knoten hinzufgen
              new(tableRecord);
              FillMemory(tableRecord,SizeOf(TDSFieldRec),$0);
              StrLCopy(tableRecord^.Name,fieldName,SizeOf(tableRecord^.Name)-1);
              tableRecord^.TypeCode:=fieldType;
              StrLCopy(tableRecord^.TypeString,tmpString,SizeOf(tableRecord^.TypeString)-1);
              tableRecord^.Length:=fieldLength;
              tableRecord^.LengthNoTern:=fieldLengthNoTerm;
              tableRecord^.Number:=j;
              tableRecord^.ParentNumber:=i;
              AddChildObject(tmpNode,fieldName,tableRecord);

              // gesamte Lnge eines Listensatzes der Tabelle (Liste) erfassen
              tableLength:=tableLength+fieldLength;
              tableLengthNoTern:=tableLengthNoTern+fieldLengthNoTerm;

            end;
            // gesamte Lnge eines Listensatzes zu Stammknoten hinzufgen
            tmpNode.Text:=tmpNode.Text+'  '+IntToStr(tableLength)+ ' Byte';
            // Daten fr Listensatzbeschreibung aktualisieren
            PDSFieldRec(tmpNode.Data)^.LengthNoTern:=tableLengthNoTern;
            PDSFieldRec(tmpNode.Data)^.Length:=tableLength;
          end;
        end;
      end;
      // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    end;
  end;
  Result:=err;
end;
//----------------------------------------------------------------------------------------------------------------------
function GetDsDescription(SourceId: Cardinal; Dest: TObject; BusNumber: Integer; ByMethod: Integer=1): Integer;
var
  i                  : Integer;
  j                  : Integer;
  err                : Integer;
  tmpNode            : TTreeNode;
  tmpString          : array [0..255] of AnsiChar;

  fieldCount         : Integer;
  fieldName          : array [0..16] of AnsiChar;
  fieldType          : Integer;
  fieldLength        : Integer;                    // mit NullTerminierung
  fieldLengthNoTerm  : Integer;                    // ohne NullTerminierung

  tableName          : array [0..16] of AnsiChar;
  tableLength        : Integer;                    // mit NullTerminierung
  tableLengthNoTern  : Integer;                    // ohne NullTerminierung
  tableRecord        : PDSFieldRec;                // in LinkSDFComDLL definiert

begin

  err:=0;

  if(ByMethod > 0)then begin

    // Prfen ob eine gltige Verbindung zum Gert oder zu einer SourceQuelle besteht
    if(DFCGetComPort(SourceId)=-1)then begin
      Result:=-1; Exit;
    end;

    // wenn Methode =1 wird direkt vom Gert die Datensatzbeschreibung gelesen
    if(ByMethod = 1)then begin

      // Datensatzbeschreibung aus Gert laden
      if(DFCLoadDatensatzbeschreibung(SourceId,BusNumber,@err)=0) then begin
        Result:=err; Exit;
      end;
      //~~~~~~~~~~~~~~~ Dest Sender TTreeView ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      if(Dest is TTreeView)then begin
        with (Dest as TTreeView).Items do
        begin
          Clear;
          for i:=0 to DFCDatBCnt(SourceId)-1 do begin
            tableLength:=0;
            tableLengthNoTern:=0;

            // Name der Tabelle und Anzahl Felder ermitteln
            DFCDatBDatensatz(SourceId, i, @tableName, @fieldCount);

            // Stammknoten hinzufgen
            new(tableRecord);
            FillMemory(tableRecord,SizeOf(TDSFieldRec),$0);
            StrLCopy(tableRecord^.Name,tableName,SizeOf(tableRecord^.Name)-1);
            tableRecord^.TypeCode:=0;
            tableRecord^.Number:=i;
            tableRecord^.ParentNumber:=-1;
            tmpNode := AddObject(nil, tableName, tableRecord);

            for j:=0 to fieldCount-1 do begin
              DFCDatBFeld(SourceId, i, j, @fieldName, @fieldType, @fieldLength);
              fieldLengthNoTerm:=fieldLength;

              StrCopy(tmpString,PansiChar(DecodeFieldType(fieldType)));
              if(fieldType=3)or(fieldType=4)then begin
                Dec(fieldLengthNoTerm);
              end;
              // Untergeordneten Knoten hinzufgen
              new(tableRecord);
              FillMemory(tableRecord,SizeOf(TDSFieldRec),$0);
              StrLCopy(tableRecord^.Name,fieldName,SizeOf(tableRecord^.Name)-1);
              tableRecord^.TypeCode:=fieldType;
              StrLCopy(tableRecord^.TypeString,tmpString,SizeOf(tableRecord^.TypeString)-1);
              tableRecord^.Length:=fieldLength;
              tableRecord^.LengthNoTern:=fieldLengthNoTerm;
              tableRecord^.Number:=j;
              tableRecord^.ParentNumber:=i;
              AddChildObject(tmpNode,fieldName,tableRecord);

              // gesamte Lnge eines Datensatzes der Tabelle erfassen
              tableLength:=tableLength+fieldLength;
              tableLengthNoTern:=tableLengthNoTern+fieldLengthNoTerm;

            end;
            // gesamte Lnge eines Datensatzes zu Stammknoten hinzufgen
            tmpNode.Text:=tmpNode.Text+'  '+IntToStr(tableLength)+ ' Byte';
            // Daten fr Datensatzbeschreibung aktualisieren
            PDSFieldRec(tmpNode.Data)^.LengthNoTern:=tableLengthNoTern;
            PDSFieldRec(tmpNode.Data)^.Length:=tableLength;
          end;
        end;
      end;
      // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    end;
  end;
  Result:=err;
end;
//----------------------------------------------------------------------------------------------------------------------
function DsData(SourceId: Cardinal; Dest: TObject; BusNumber: Integer; ByMethod: Integer=1): Integer;
var
  i                  : Integer;
  j                  : Integer;
  k                  : Integer;
  m                  : Integer;
  msgs               : AnsiString;
  msgi               : Integer;
  err                : Integer;

  NewTabSheet        : TTabSheet;
  NewListItem        : TListItem;
  NewListView        : array [0..19] of TListView;

  fieldCount         : Integer;                    // die Anzahl Felder in einem RecordData
  fieldName          : array [0..16] of AnsiChar;      // Name eines Feldes (ist auch Name einer Spalte)
  fieldType          : Integer;                    // kann 2,3 und 4 sein
  fieldLength        : Integer;                    // mit NullTerminierung
  fieldData          : array [0..20] of AnsiChar;      // Puffer fr Daten eines Feldes

  RecordName         : array [0..16] of AnsiChar;
  RecordLength       : Integer;                    // mit NullTerminierung
  RecordData         : array [0..255] of AnsiChar;     // Rohdaten aus dem Gert
  RecordOffs         : Integer;                    // Offsetzhler fr Rohdaten

  fp                 : TextFile;
  FileRec            : AnsiString;                     // aufbereitetes RecordData zum speichern in eine Datei

begin

  Application.ProcessMessages();
  err:=0;

  // ~~~~~~~~~~~~~~~~~~~~~~~~~~~ Listen auf den TabSheets leeren ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if(ByMethod=0)and (Dest is TPageControl) then begin
    with (Dest as TPageControl) do begin
      if(PageCount>0)then begin
        for i:=0 to PageCount-1 do begin
          for j:=0 to Pages[i].ComponentCount-1 do begin
            if(Pages[i].Components[j] is TListView) then begin
               (Pages[i].Components[j] as TListView).Items.Clear;
            end;
          end;
        end;
      end;
    end;
  end;
  // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


  if(ByMethod > 0)then begin

    // Prfen ob eine gltige Verbindung zum Gert besteht
    if(DFCGetComPort(SourceId)=-1)then begin
      Result:=-1; Exit;
    end;


    // wenn Methode =1 wird direkt vom Gert die Datensatzbeschreibung gelesen
    if(ByMethod = 1)then begin
      DFCSetCallBack(SourceId,@OnProgress);                 // nur zur Demo nicht unbedingt notwendig
      //~~~~~~~~~~~~~~~ Dest Sender TPageControl ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      if(Dest is TPageControl)then begin
        with (Dest as TPageControl) do begin

          // Datensatzbeschreibung aus Gert laden
          if(DFCLoadDatensatzbeschreibung(SourceId,BusNumber,@err)=0) then begin
            Result:=err;
            DFCSetCallBack(SourceId,nil);    // Rcksetzen der Callbackfunktion, falls Fehler
            Exit;
          end;

          // berprfen ob es schon Eintrge in den Listen gibt (k)
          k:=0;
          if(PageCount>0)then begin
            for i:=0 to PageCount-1 do begin
              for j:=0 to Pages[i].ComponentCount-1 do begin
                if(Pages[i].Components[j] is TListView) then begin
                  k:=k+(Pages[i].Components[j] as TListView).Items.Count;
                end;
              end;
            end;
          end;

          // --BEGIN-------- Elemente erzeugen -- nur wenn noch keine Eintrge in der Liste vorhanden sind
          if(k=0) then begin
            // bestehende TabSheets des PageControls lschen
            for i:=PageCount-1 downto 0 do begin
              Pages[i].Free;
            end;

            // soviele neue TabSheets mit je einem TListView erzeugen wie
            // es Datensatzbeschreibungen im Gert gibt
            for i:=0 to DFCDatBCnt(SourceId)-1 do begin
              DFCDatBDatensatz(SourceId, i, @RecordName, @fieldCount);

              // Neues TabSheet anlegen
              NewTabSheet:= TTabSheet.Create(Dest as TPageControl);
              NewTabSheet.PageControl:=(Dest as TPageControl);
              NewTabSheet.Parent:=(Dest as TPageControl);
              NewTabSheet.Name:='NewTabSheet'+IntToStr(i);
              NewTabSheet.Caption:=RecordName;

              // Neues ListView anlegen
              NewListView[i]:=TListView.Create(NewTabSheet);
              NewListView[i].Name:='NewListView'+IntToStr(i);
              NewListView[i].Parent:=NewTabSheet;
              NewListView[i].Top:=2;
              NewListView[i].Left:=4;
              NewListView[i].Height:=302;
              NewListView[i].Width:=462;
              NewListView[i].ViewStyle:=vsReport;
              NewListView[i].Visible:=True;
              NewListView[i].FlatScrollBars:=True;
              NewListView[i].GridLines:=True;

              // Spalten anlegen und Feldnamen als Spaltenname definieren
              for j:=0 to fieldCount-1 do begin
                DFCDatBFeld(SourceId, i, j, @fieldName, @fieldType, @fieldLength);
                NewListView[i].Columns.Add;
                NewListView[i].Columns[j].AutoSize:=True;
                NewListView[i].Columns[j].Caption:=fieldName;
              end;
              // ~~~~~~~ TRICK FR AUTOSIZE-PROBLEM ~~~~~~~~~~~~~~~~~~~~
              if i=0 then begin
                NewListView[i].Width:=NewListView[i].Width+1;
                NewListView[i].Width:=NewListView[i].Width-1;
              end;
              // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            end;
          end; //--ENDE------- Elemente erzeugen


          // alle vorhandnen Daten aus dem Gert auslesen
          msgi:=DFCComCollectData(SourceId,BusNumber,@err);
//-->
          //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          while msgi>0 do begin
            FillChar(RecordData, SizeOf(RecordData), #0);
            FileRec:='';
            // Wichtig, da die Nutzdaten erst ab Index 1 beginnen
            RecordOffs:=1;

            // Datensatz wird aus DLL-Puffer nach RecordData kopieren
            msgi:=DFCComGetDatensatz(SourceId,RecordData,@RecordLength,@err);

            // ermitteln welche DS-Beschreibung zum Record gehrt
            DFCDatBDatensatz(SourceId, Cardinal(RecordData[0]), @RecordName, @fieldCount);

            // der DS-BeschreibungsNr entsprechend, an das richtige ListView ein Item anhngen
            for j:=0 to Pages[Cardinal(RecordData[0])].ComponentCount-1 do begin
              if(Pages[Cardinal(RecordData[0])].Components[j] is TListView) then begin
                NewListItem:=(Pages[Cardinal(RecordData[0])].Components[j] as TListView).Items.Add;
              end;
            end;


            // aktuelles Datenfeld auswerten und aufbereiten
            for i:=0 to fieldCount-1 do begin
              DFCDatBFeld(SourceId, Cardinal(RecordData[0]), i, @fieldName, @fieldType, @fieldLength);

              case fieldType of
                1 :begin  // Nicht erlaubt
                    Break;
                end;

                2 :begin  // fest  7 Byte (yyyy,mm,dd-h:m:s)
                  k:=RecordOffs;

                  // berprfen ob nicht alle 7 Byte im Record Null sind
                  m:=0;
                  for j:=0 to 6 do begin
                    if(Cardinal(RecordData[k+j])>0) then begin
                      m:=1; Break;
                    end;
                  end;

                  // wenn im Datum/Uhrzeit-Record Werte waren, diese zum entsprechend formatierten String verarbeiten
                  if(m=1) then begin
                    msgs:=Format('%.2u%.2u-%.2u-%.2u %.2u:%.2u:%.2u',[Cardinal(RecordData[k+0]),Cardinal(RecordData[k+1]),
                                 Cardinal(RecordData[k+2]),Cardinal(RecordData[k+3]),Cardinal(RecordData[k+4]),
                                 Cardinal(RecordData[k+5]),Cardinal(RecordData[k+6])]);

                    StrLCopy (fieldData, PAnsiChar(msgs), SizeOf(fieldData)-1);
                   end else begin
                    // waren keine Werte im Datum/Uhrzeit-Record, dann Puffer mit #0 fllen
                    FillChar(fieldData,SizeOf(fieldData),#0);
                  end;
                  RecordOffs:=RecordOffs+7;
                end;

                3,        // max  20 Byte (es sind jedoch nur Ziffern erlaubt)
                4 :begin  // max  20 Byte (Alpha-Numerisch ASCII)
                  for j:=0 to fieldLength-1 do begin
                    fieldData[j]:=RecordData[RecordOffs];
                    Inc(RecordOffs);
                  end;
                end;

                5,
                6 :begin  // Nicht erlaubt
                    Break;
                end;
              end; //CASE

              // Felddaten ins ListView schreiben
              if(i=0)then NewListItem.Caption:=fieldData;
              if(i>0)then NewListItem.SubItems.Add(String(fieldData));


              // aktuelles Datenfeld in den Puffer fr Ausgabedatei schreiben
              if i<(fieldCount-1) then begin
                FileRec:=FileRec+fieldData +#9;
               end else begin
                FileRec:=FileRec+fieldData;
              end;
            end;


            // entsprechend der DS-Beschreibung notwendige Datei zum schreiben ffnen
            AssignFile(fp,RecordName+'.txt');
            FileMode:=fmOpenReadWrite;
            if not FileExists(RecordName+'.txt') then begin Rewrite(fp); end
            else begin Append(fp); end;
            // Datensatz in Datei schreiben
            Writeln(fp,FileRec);
            CloseFile(fp);

            // wenn der Returnwert des letzen DFCComCollectData 2 war, hat es sich um den
            // letzen Datensatz im Gert gehandelt. While-Schleife dann beenden.
            if(msgi=2) then begin Result:=0; Break; end;
          end; // Ende While
          //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//-->
          // Fehler oder keine Daten
          if(msgi=-1)or(msgi=0) then begin
            Result:=err;
            DFCSetCallBack(SourceId,nil);    // Rcksetzen der Callbackfunktion
            Exit;
          end;

        end;  // Ende  with PageControl
      end;  // Ende ist PageControl

    end;  // Methode=1
  end;  // Methode>1
  DFCSetCallBack(SourceId,nil);  // Rcksetzen der Callbackfunktion
  Result:=err;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.FormCreate(Sender: TObject);
begin

  // ~~~~~~~~~~~ Programm an Auflsung (z.B. 120DPI) anpassen ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if(Screen.PixelsPerInch <> 96)then begin
    Scaled:=True;
    ScaleBy(Screen.PixelsPerInch, 96);
  end;
  Constraints.MaxHeight:=Height;
  Constraints.MaxWidth:=Width;
  Constraints.MinHeight:=Height;
  Constraints.MinWidth:=Width;
  Scaled:=False;
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Application.HintHidePause:=15000;
  Application.HintPause:=500;
  Application.HintColor:=$00E7DEC9;
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  mPageControl:=nil;
  mListView:=nil;
  tmpTList:=nil;
  tmpgInt:=0;

  ChannelNum:=1;
  Button2.Enabled:=False;
  Label1.Visible:=False;
  Label3.Visible:=False;
  Label5.Visible:=False;
  Label6.Visible:=False;
  Edit2.Visible:=False;
  Edit3.Visible:=False;
  ComboBox1.Visible:=False;
  ComboBox2.Visible:=False;
  ComboBox3.ItemIndex:=14;     // TimeOut    600 ms
  ComboBox3.Visible:=False;
  ComboBox5.ItemIndex:=0;      // Busnummer  254
  ComboBox5.Visible:=False;

end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.ComboBox1DropDown(Sender: TObject);
begin
  // verfgbare COM-Schnittstellen ermitteln
  SerialPortList(Sender,bmWinAPI);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.ComboBox1Change(Sender: TObject);
var
  tmpString        : String;
  i                : Integer;
begin

  tmpString:=ComboBox1.Items[ComboBox1.ItemIndex];
  // aus COM-String, ChannelNummer extrahieren
  ChannelNum:=StrToInt(AnsiReplaceText(tmpString,'COM',''));
  Edit1.Text:=IntToStr(ChannelNum);
  // COM-String ins ComPort-Array kopieren
  for i:=0 to Length(tmpString)-1 do begin
    ComPort[i]:=tmpString[i+1];
  end;
 end;
//---------------------------------------------------------------------------------------------------------------------- 
procedure TForm3.ComboBox4Change(Sender: TObject);
begin

  if(ComboBox4.ItemIndex=0)then begin
    ComboBox1.Visible:=True;
    Edit2.Visible:=False;
    Label1.Visible:=True;
    Label1.Caption:='Schnittstelle';
    Edit3.Visible:=False;
    Label5.Visible:=True;
    Label5.Caption:='Baud Rate';
    ComboBox3.ItemIndex:=14;     // TimeOut    600 ms
    ComboBox2.ItemIndex:=2;      // BaudRate   38400 Baud
    ComboBox2.Visible:=True;
    Edit3.Visible:=False;
  end;

  if(ComboBox4.ItemIndex=1)then begin
    ChannelNum:=1;
    Edit1.Text:=IntToStr(ChannelNum);
    ComboBox1.Visible:=False;
    Edit2.Visible:=True;
    Label1.Visible:=True;
    Label1.Caption:='IP-Adresse';
    Edit3.Visible:=True;
    Label5.Visible:=True;
    Label5.Caption:='IP-Port';
    ComboBox3.ItemIndex:=21;     // TimeOut  3000 ms
    ComboBox2.Visible:=False;
    Edit3.Visible:=True;
    Edit3.Text:='8000';          // PortNummer
  end;

  ComboBox3.Visible:=True;
  ComboBox5.Visible:=True;
  Label3.Visible:=True;
  Label6.Visible:=True;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.Button1Click(Sender: TObject);
var
  err            : Integer;
  Version        : array [0..32] of ansiChar;
  SerialNum      : Integer;
begin

  BusNum:=StrToInt(ComboBox5.Items[ComboBox5.ItemIndex]);   // BusNummer
  TimeOut:=StrToInt(ComboBox3.Items[ComboBox3.ItemIndex]);  // TimeOut

  if(ComboBox4.ItemIndex=0)then begin
    // RS232
    if(DFCComOpenIV(ChannelNum,BusNum,1,ComPort,StrToInt(ComboBox2.Items[ComboBox2.ItemIndex]),TimeOut)=1) then begin
      Button2.Enabled:=True;
      Button1.Enabled:=False;
      StatusBar1.Panels[0].Text:=' Verbindung mit '+ComPort+' hergestellt.';
      Panel1.Enabled:=False;
      DFCGetSeriennummer(ChannelNum,BusNum,@err,@SerialNum);
      if(err=0)then begin Label11.Caption:=IntToStr(SerialNum); end
        else begin Label11.Caption:='xxxx'; end;
      DFCGetVersionFirmware(ChannelNum,BusNum,@Version,@err);
      if(err=0)then begin Label13.Caption:=Version; end
        else begin Label13.Caption:='xx.xx.xx'; end;
     end else begin
      Button1.Enabled:=True;
      Button2.Enabled:=False;
      StatusBar1.Panels[0].Text:='';
      Label11.Caption:='xxxx';
      Label13.Caption:='xx.xx.xx';
      ShowMessage('Es konnte keine Verbindung zu '+ComPort+' hergestellt werden');
      Panel1.Enabled:=True;
    end;
  end;

  if(ComboBox4.ItemIndex=1)then begin
    // TCP-IP
    if(DFCComOpenIV(ChannelNum,BusNum,3,PAnsiChar(ansistring(Edit2.Text)),StrToInt(Edit3.Text),TimeOut)=1) then begin
      Button2.Enabled:=True;
      Button1.Enabled:=False;
      StatusBar1.Panels[0].Text:=' Verbindung zur IP: '+Edit2.Text+' Port: '+Edit3.Text+' hergestellt.';
      Panel1.Enabled:=False;
      DFCGetSeriennummer(ChannelNum,BusNum,@err,@SerialNum);
      if(err=0)then begin Label11.Caption:=IntToStr(SerialNum); end
        else begin Label11.Caption:='xxxx'; end;
      DFCGetVersionFirmware(ChannelNum,BusNum,@Version,@err);
      if(err=0)then begin Label13.Caption:=Version; end
        else begin Label13.Caption:='xx.xx.xx'; end;
     end else begin
      Button1.Enabled:=True;
      Button2.Enabled:=False;
      StatusBar1.Panels[0].Text:='';
      Label11.Caption:='xxxx';
      Label13.Caption:='xx.xx.xx';
      ShowMessage('Es konnte keine Verbindung zur IP: '+Edit2.Text+' Port: '+Edit3.Text+' hergestellt werden');
      Panel1.Enabled:=True;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.Button2Click(Sender: TObject);
begin

  // Verbindung schliessen
  StatusBar1.Panels[0].Text:='';
  DFCComClose(ChannelNum);
  StatusBar1.Panels[0].Text:=' Verbindung geschlossen.';
  Button1.Enabled:=True;
  Button2.Enabled:=False;
  Panel1.Enabled:=True;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.Button3Click(Sender: TObject);
var
  err            : Integer;
begin

  err:=GetDsDescription(ChannelNum,TreeView1,BusNum);
  if(err=-1) then begin ShowMessage('Es gab keine gltige Quelle die als Source angegeben ist'); end;
  if(err>0) then begin ShowMessage('Fehler Nr. '+IntToStr(err)+' aufgetreten'); end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.TreeView1Click(Sender: TObject);
begin

  if(TreeView1.Items.Count>0) then begin
    StatusBar1.Panels[0].Text:=' '+
                               PDSFieldRec(TreeView1.Selected.Data)^.Name+'  '+
                               PDSFieldRec(TreeView1.Selected.Data)^.TypeString+'   '+
                               IntToStr(PDSFieldRec(TreeView1.Selected.Data)^.Length)+' Byte';

    Edit4.Text:=PDSFieldRec(TreeView1.Selected.Data)^.Name;
    Edit5.Text:=PDSFieldRec(TreeView1.Selected.Data)^.TypeString;
    Edit6.Text:=IntToStr(PDSFieldRec(TreeView1.Selected.Data)^.LengthNoTern);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.Button4Click(Sender: TObject);
var
  err            : Integer;
begin

  ProgressBar1.Position:=0;
  if(mPageControl=nil)and(DFCGetComPort(ChannelNum)>-1) then begin
    mPageControl:= TPageControl.Create(Self);
    mPageControl.Parent:=Panel7;
    mPageControl.Top:=1;
    mPageControl.Left:=1;
    mPageControl.Height:=341;
    mPageControl.Width:=479;
  end;

  err:=DsData(ChannelNum,mPageControl,BusNum);
  if(err=-1) then begin
    ShowMessage('Es gab keine gltige Quelle die als Source angegeben ist');
  end;
  if(err>0) then begin ShowMessage('Fehler Nr. '+IntToStr(err)+' aufgetreten'); end;
  ProgressBar1.Position:=0;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.Button5Click(Sender: TObject);
var
  err            : Integer;
begin

  // Listeneintrge lschen
  if(mPageControl<>nil) then begin
    err:=DsData(ChannelNum,mPageControl,BusNum,0);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.FormShow(Sender: TObject);
begin

  SetControlToPanel(ProgressBar1,StatusBar1,1);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TForm3.Button6Click(Sender: TObject);
var
  err            : Integer;
begin

  err:=GetLsDescription(ChannelNum,TreeView1,BusNum);
  if(err=-1) then begin ShowMessage('Es gab keine gltige Quelle die als Source angegeben ist'); end;
  if(err>0) then begin ShowMessage('Fehler Nr. '+IntToStr(err)+' aufgetreten'); end;
end;
//----------------------------------------------------------------------------------------------------------------------
end.


